import codeanticode.syphon.*;
import org.openkinect.freenect.*;
import org.openkinect.processing.*;
import s373.flob.*;
import oscP5.*;
import netP5.*;

Flob flob;
OscP5 osc;
NetAddress izzyloop;
int OSCPort = 7000;
int OSCEars = 5001;

KinectTracker tracker;
Kinect kinect;
SyphonServer server;

PVector v1;
PVector v2;

//Multiflob
boolean depth = true;
boolean rgb = true;
boolean ir = false;
int[] adepth;
PImage vrImage;
PImage timg;
PGraphics words;

int videores=256;//64//256
int maxthreshold = 745;
int minthreshold = 650;
ArrayList blobs = new ArrayList();

// Initial sketch
int state = 5;
int butstate;

// Only needed if moving thru sketches on a fixed time rotation
// int time;

int t;
int mt;
float deg;
 
void setup(){
  size(640,520,OPENGL);
  //PJOGL.profile=1;
  osc = new OscP5(this, OSCEars);
  izzyloop = new NetAddress("127.0.0.1",OSCPort);
  kinect = new Kinect(this);
  tracker = new KinectTracker();
  deg = kinect.getTilt();
  server = new SyphonServer(this, "Playlist_Sketch");
  frameRate(30);
  triggered();
  //time = millis() + 20000;
}
 
void draw(){
  
  tracker.track();
  v1 = tracker.getPos();
  v2 = tracker.getLerpedPos();
  OscMessage myMsg = new OscMessage("/fabric/handpos");
  myMsg.add(new Object[] {v1.x/(width/100),v1.y/(width/100)});
  osc.send(myMsg, izzyloop);
  OscMessage myMsg2 = new OscMessage("/fabric/lerppos");
  myMsg2.add(new Object[] {v2.x/(width/100),(v2.y/(width/100))*(0-1)});
  OscMessage myMsg3 = new OscMessage("/fabric/found");
  myMsg3.add(new Object[] {tracker.found});
  OscMessage myMsg4 = new OscMessage("/fabric/ifound");
  myMsg4.add(new Object[] {tracker.ifound});
  osc.send(myMsg, izzyloop);
  osc.send(myMsg2, izzyloop);
  osc.send(myMsg3, izzyloop);
  osc.send(myMsg4, izzyloop);
  switch(state){
    case 0:
      draw0();
      //server.sendScreen();
      break;
    case 1:
      draw1();
      server.sendScreen();
      break;
    case 2:
      draw2();
      //server.sendScreen();
      break;
    case 3:
      draw3();
      //server.sendScreen();
      break;
    case 4:
      draw4();
      //server.sendScreen();
      break;
    case 5:
      draw5();
      //server.sendScreen();
      break;
    case 6:
      draw6();
      //server.sendScreen();
      break;
    case 7:
      draw7();
      server.sendScreen();
      break;
    case 8:
      draw8();
      server.sendScreen();
      break;
  // Send to Syphon
  
  }
  /*if(millis() >= time){
    state++;
    state%=total_states;
    if(state==0) setup0();
    if(state==1) setup1();
    if(state==2) setup2();
    if(state==3) setup3();
    if(state==4) setup4();
    if(state==5) setup5();
    time = millis() + 20000;
  }
  */
}
void triggered(){
  //if(millis() >= time){
    //state++;
    //state%=total_states;
    if(state!=7){
      Particle2[] particles2={};
      PGraphics words=createGraphics(1,1);
      words.updatePixels();
      words.clear();
    }
    if(state!=6){
      PImage vrImage;
    }
    if(state==0) setup0();
    if(state==1) setup1();
    if(state==2) setup2();
    if(state==3) setup3();
    if(state==4) setup4();
    if(state==5) setup5();
    if(state==6) setup6();
    if(state==7) setup7();
    if(state==8) setup8();
    //time = millis() + 20000;
  //}
}
// Controls.
void keyPressed() {
  if (key == '0') {
    state=0;
    triggered();
  }
  if (key == '1') {
    state=1;
    triggered();
  }
  if (key == '2') {
    state=2;
    triggered();
  }
  if (key == '3') {
    state=3;
    triggered();
  }
  if (key == '4') {
    state=4;
    triggered();
  }
  if (key == '5') {
    state=5;
    triggered();
  }
  if (key == '6') {
    state=6;
    triggered();
  }
  if (key == '7') {
    state=7;
    triggered();
  }
  if (key == '8') {
    state=8;
    triggered();
  }
  if (key == '9') {
    state=9;
    triggered();
  }
  if (key == 's') {
    saveFrame("images/screen_#####.png");
  }
  if ((key == 'q') || (key == 'Q')) {
      deg++;
      deg = constrain(deg, 0, 30);
      kinect.setTilt(deg);
  }
  if ((key == 'a') || (key == 'A')) {
      deg--;
      deg = constrain(deg, -30, 30);
      kinect.setTilt(deg);
  }

  if ((key == 'r') || (key == 'R'))
    
  if ((key == 'g') || (key == 'G'))
    toggleGravity();
  if ((key == 'd') || (key == 'D')){
    if(state==8){
      toggleDepth2();
    } else {
      toggleDepth();
    }
  }
  if ((key == 't') || (key == 'T')){
    toggleGrid();
    createCurtain();
  }
  if(key=='r'){
     flob.setThresh(flob.getThresh() - 1 );
  }
  if(key=='f'){
     flob.setThresh(flob.getThresh() + 1 );
  }
  
  t = tracker.getThreshold();
  mt = tracker.getmThreshold();
  if (key == CODED) {
    if (keyCode == UP) {
      t+=5;
      tracker.setThreshold(t);
      maxthreshold+=5;
    } else if (keyCode == DOWN) {
      t-=5;
      tracker.setThreshold(t);
      maxthreshold-=5;
    }
    else if (keyCode == LEFT) {
      mt-=5;
      tracker.setmThreshold(mt);
      minthreshold-=5;
      
    }else if (keyCode == RIGHT) {
      mt+=5;
      tracker.setmThreshold(mt);
      minthreshold+=5;
    }
    OscMessage myMsg5 = new OscMessage("/fabric/thresh");
    myMsg5.add(new Object[] {t,mt});
    osc.send(myMsg5, izzyloop);
  }
  

}

void oscEvent(OscMessage theOscMessage){
  float oscVal = theOscMessage.get(0).floatValue();
  // print out the message
  println("INCOMING OSC DOES NOTHING AT THE MOMENT!");
  println("OSC Message Received: ");
  println(" typetag: "+theOscMessage.typetag());
  println(" value: "+oscVal);
}
void stop() {
  //kinect.quit();
  //super.stop();
}
