class Particle2{
 float x,y;  //x and y locaiton of particle
 float xVel, yVel;  //x and y velocity of particle
 float xVelMax, yVelMax;  //will hold the maximum velocity for the particle
 float xAccel, yAccel;  //x and y accelaration
 float ang;  //angle in degrees that particle should be moving at
 float lifespan;
 float cutoff;
 float xGoal, yGoal;  //the point that the particle wants to return to
  // Is the particle still useful?
  boolean isDead() {
    return (lifespan < 0.0);
  }
 
 //constructor
 Particle2(float newXGoal, float newYGoal, float life){
   x=width/2;
   y=height+100;
   xGoal=newXGoal;
   yGoal=newYGoal;
   ang=random(0,2*PI);  //we're using radians
   xVel=0;
   yVel=0;
   lifespan = life;
   cutoff = life;
   
   xAccel=pAccel*cos(ang);
   yAccel=pAccel*sin(ang);
 }
 
 //deals with the frame to frame changes of the particle
 void Update(){
   x+=xVel;
   y+=yVel;
   
   xVel+=xAccel;
   yVel+=yAccel;
   
   //if the particles are not free, move this particle toward its goal
   if (!free){
     //get the ange of the point the particle should move toward
     ang= atan2(yGoal-y, xGoal-x);
     xAccel=pAccel*cos(ang);
     yAccel=pAccel*sin(ang);
     
     //slow it down a lot if it's close to the point
     if (abs(x-xGoal) <xVel*3 || abs(y-yGoal)<yVel*3){
       xVel*=0.8;
       yVel*=0.8;
     }
     lifespan -= 1.0;
   }else{
     //make it bounce off edges if it's free moving
     lifespan -= 1.0;
     CheckEdge();
   }
   
   Draw();
 }
 
 //draws the particle on screen
 void Draw(){
   noStroke();
   fill(255,65);
   rect(x,y,5,5);
 }
  
 void CheckEdge(){
  
   if (x>width+100 || x<0-100 || y>height+100 || y<0-100){
     xVel=0;
     yVel=0;
     if (y>height+100){
       yAccel*=-1;
       y=height+5;
     }else if (y<0-100){
       yAccel*=-1;
       y=-5;
     }else if (x>width+100){
       xAccel*=-1;
       x=width+5;
     }else if (x<0-100){
       xAccel*=-1;
       x=-5;
     }
   }
   
   
   /*
   if (x>width || x<0){
     ang+=PI;
     println("hitEdge");
   }
   if (y>height || y<0){
     ang+=PI;
     println("hitEdge");
   }
   */
 }
  
  
}
