/* OpenProcessing Tweak of *@*http://www.openprocessing.org/sketch/1120*@* */
/* !do not delete the line above, required for linking your tweak if you upload again */
Particle1[] particles1;
int     particleCount        = 1000;
int     initSpeed            = 5;
float   bounceStrength       = 0.3;
float   gravityStrength      = 0.1;
float   mouseStrength        = 0.3;
//float   mouseDistPowerLoss   = 1.1;
float   mouseMaxDist         = 150;
boolean drawLines            = true;
boolean drawSphere           = false;
int     particle_opacity     = 100;
int     eraser_opacity       = 10;
PVector v1b;
PVector v2b; 
int sx1 = 640;
int sy1 = 520;

void setup1() {
  size(640,520, OPENGL);
  colorMode(RGB, 255);
  background(0);
  smooth();
  //frameRate(60);
  v1b = tracker.getPos();
  v2b = tracker.getLerpedPos();
  createParticles();
}

void draw1() {
  tracker.track();
  v1b = tracker.getPos();
  v2b = tracker.getLerpedPos();
  stroke(0);
  strokeWeight(2);
  fill(0,eraser_opacity);
  rect(0,0,sx1,sy1);

  if (drawSphere) {
    // draw influence sphere
    fill(0,0,200,10);
    ellipse(v1b.x,v1b.y,2*mouseMaxDist,2*mouseMaxDist);
  }
  
  stroke(255,255,255,particle_opacity);
  strokeWeight(2);
  for (int i=0;i<particleCount;i++) {
    particles1[i].move();
    particles1[i].render();
  }  
  //server.sendScreen();
}

void createParticles() {
  particles1 = new Particle1[particleCount];
  for (int i=0;i<particleCount;i++) {
    particles1[i] = new Particle1(random(sx1), 9*sy1/10+random(sy1/10), initSpeed*(random(1)-0.5), initSpeed*(random(1)-0.5));
  }
}


