

void setup6() {
  size(640,520,OPENGL);
  
    // downscale image to ease flob processing load
  vrImage = createImage(videores, videores, RGB);
  //flob = new Flob(vrImage, this); 
   flob = new Flob(this, videores, videores, 640, 480);
   
  
  flob.setThresh(20).setSrcImage(3).setBackground(vrImage)
    .setOm(0).setFade(25).setMirror(false, false);
  flob.setTBlobLifeTime(5); 
    // new kinect specific code can clamp kinect image (or other images)
    // between values of nearGray and farGray (works on 8bit 0-255 limits)
  
  //flob.setClampGray(true).setNearGray(10).setFarGray(80);
  //boolean feats[] = {true,true,true,true,true};
  //flob.setTrackFeatures( feats );
  adepth = kinect.getRawDepth();
  rectMode(CENTER);
  textFont(createFont("monospace",16));
  
}


void draw6() {
  background(0,0);    
    timg = createImage(kinect.width, kinect.height, RGB);
    // Being overly cautious here
    if (adepth == null) return;
  
    timg.loadPixels();
    
    for (int x = 0; x < kinect.width; x++) {
      for (int y = 0; y < kinect.height; y++) {
        
        int offset = x + y * kinect.width;
        // Raw depth
        int rawDepth = adepth[offset];
        int pix = x + y * timg.width;
        if (rawDepth >= minthreshold && rawDepth <= maxthreshold) {
          // A red color instead
          timg.pixels[pix] = color(150, 50, 50);
          
        } else {
          timg.pixels[pix] = color(0,0,0);
          
        }
      }
    }
    timg.updatePixels();
 
  {
    vrImage.copy(timg, 0, 0, 640, 480, 0, 0, videores, videores);
    blobs=flob.track(flob.binarize(vrImage));    
  }
  
  image(flob.getSrcImage(), 0, 0, 640, 480);
  int numblobs = flob.getNumBlobs();  
  if (blobs.size()>0) {
    for (int i = 0; i < blobs.size(); i++) {
      ABlob ab = (ABlob)flob.getTBlob(i);
      
      OscMessage myMsg = new OscMessage("/blobs/"+i+"/pos");
      myMsg.add(new Object[] {(ab.cx/(width/100))-50, ((ab.cy/(height/100))*(0-1))-50});
      OscMessage myMsg2 = new OscMessage("/blobs/"+i+"/dim");
      myMsg2.add(new Object[] {(ab.dimx/(width/100)), ab.dimy/(height/100)});
      
      //box
      fill(0, 0, 255, 100);
      rectMode(CENTER);
      rect(ab.cx, ab.cy, ab.dimx, ab.dimy);
      //centroid
      fill(0, 255, 0, 200);
      rect(ab.cx, ab.cy, 5, 5);

      osc.send(myMsg, izzyloop);
      osc.send(myMsg2, izzyloop);
      /*
      line(ab.cx, ab.cy, ab.armleftx, ab.armlefty);
      line(ab.cx, ab.cy, ab.armrightx, ab.armrighty);
      line(ab.cx, ab.cy, ab.headx, ab.heady);
      line(ab.cx, ab.cy, ab.bottomx, ab.bottomy);
      line(ab.cx, ab.cy, ab.footleftx, ab.footlefty);
      line(ab.cx, ab.cy, ab.footrightx, ab.footrighty);
      */
    }
  }

  //report presence graphically
  fill(255, 152, 255);
  rectMode(CORNER);
  rect(10, 10, flob.getPresencef()*width, 10);
  String stats = ""+frameRate+"\nflob.numblobs: "+numblobs+"\nflob.thresh:"+flob.getThresh()+
    " <t/T>"+"\nflob.fade:"+flob.getFade()+"   <f/F>"+"\nflob.om:"+flob.getOm()+
    "\nflob.image:"+flob.videotexmode+"\nflob.presence:"+flob.getPresencef();
  fill(0, 255, 0);
  text(stats, 5, 25);
  server.sendScreen();
}


void setThreshold(int t) {
  maxthreshold =  t;
}
void setmThreshold(int t) {
  minthreshold =  t;
}
